
#ifndef SOUND_H
#define SOUND_H
#ifdef __cplusplus
extern "C" {
#endif


// ɤ

// REG_SGCNT0_L

#define DMG_LEFT_VOLUME(x)	((x)<<0) // 0-7
#define DMG_RIGHT_VOLUME(x)	((x)<<4) // 0-7

#define SOUND1_LEFT_OUTPUT	(1<<8)
#define SOUND2_LEFT_OUTPUT	(1<<9)
#define SOUND3_LEFT_OUTPUT	(1<<10)
#define SOUND4_LEFT_OUTPUT	(1<<11)
#define SOUND1_RIGHT_OUTPUT	(1<<12)
#define SOUND2_RIGHT_OUTPUT	(1<<13)
#define SOUND3_RIGHT_OUTPUT	(1<<14)
#define SOUND4_RIGHT_OUTPUT	(1<<15)


// REG_SGCNT0_H

#define SOUND_OUTPUT_RATIO(x)	((x)<<0) // ɽϥ쥷 0-2 (0=25%,1=50%,2=100%)


// REG_SGCNT1

#define SOUND1_STATUS	(1<<0) // ɤξ
#define SOUND2_STATUS	(1<<1) // ɤξ
#define SOUND3_STATUS	(1<<2) // ɤξ
#define SOUND4_STATUS	(1<<3) // ɤξ
#define ALL_SOUND_ENABLE	(1<<7) // ɻ



// 1
// פΤ륨٥ײ

// REG_SG10_L

#define SOUND1_SWEEP_SHIFT(x)	((x)<<0) // ץե 0-7
#define SOUND1_SWEEP_INC		(0<<3) // 
#define SOUND1_SWEEP_DEC		(1<<3) // ׸
#define SOUND1_SWEEP_TIME(x)	((x)<<4)	// ׻ 0-7

// REG_SG10_H

#define SOUND1_LENGTH(x)	((x)<<0) // ɤĹ 0-63
#define SOUND1_DUTY_CYCLE(x)	((x)<<6) // ǥ塼ƥ 0-3
#define SOUND1_ENVELOP_STEP(x)	((x)<<8) // ٥ץƥå׻ 0-7
#define SOUND1_ENVELOP_DEC		((0)<<11) // ٥׸
#define SOUND1_ENVELOP_INC		((1)<<11) // ٥
#define SOUND1_ENVELOP_VALUE(x)	((x)<<12) // ٥׽ 0-15


// REG_SG11

#define SOUND1_FREQ(x)	((x)<<0) //  0-2048
#define SOUND1_CONTINUE	(0<<14) // ³
#define SOUND1_TIMED	(1<<14) // 
#define SOUND1_RESET	(1<<15) // 1ꥻå


// ɣפΤʤ٥ײ
// 1REG_SG10_H,REG_SG11Ʊ

// REG_SG20
#define SOUND2_LENGTH(x)	((x)<<0) // ɤĹ 0-63
#define SOUND2_DUTY_CYCLE(x)	((x)<<6) // ǥ塼ƥ 0-3
#define SOUND2_ENVELOP_STEP(x)	((x)<<8) // ٥ץƥå׻ 0-7
#define SOUND2_ENVELOP_DEC		((0)<<11) // ٥׸
#define SOUND2_ENVELOP_INC		((1)<<11) // ٥
#define SOUND2_ENVELOP_VALUE(x)	((x)<<12) // ٥׽ 0-15

// REG_SG21
#define SOUND2_FREQ(x)	((x)<<0) //  0-2048
#define SOUND2_CONTINUE	(0<<14) // ³
#define SOUND2_TIMED	(1<<14) // 
#define SOUND2_RESET	(1<<15) // 1ꥻå


// ɣ
// 

// REG_SG30_L

#define SOUND3_BANK_2x32	(0<<5) // 32bitΥХ
#define SOUND3_BANK_1x64	(1<<5) // 64bitΥХ󥯰

// Х󥯤 򤷤Ƥʤۤ񤭹
#define SOUND3_BANK_SELECT(x)	((x)<<6) // 0-1

#define SOUND3_OUTPUT_ENABLE	(1<<7) // 3
#define SOUND3_OUTPUT_DISABLE	(0<<7) // 3Ϥʤ


// REG_SG30_H

#define SOUND3_LENGTH(x)	((x)<<0)	// ɤĹ 0-255
#define SOUND3_VOLUME_RATIO(x)	((x)<<13)	// ܥ塼ϥ쥷 0-4 1100%


// REG_SG31

#define SOUND3_FREQ(x)	((x)<<0) //  0-2048
#define SOUND3_CONTINUE	(0<<14) // ³
#define SOUND3_TIMED	(1<<14) // 
#define SOUND3_RESET	(1<<15) // 1ꥻå


// REG_SGWR0
// REG_SGWR0_L
// REG_SGWR0_H
// REG_SGWR3


// 4

// REG_SG40
#define SOUND4_LENGTH(x)	((x)<<0) // ɤĹ 0-63
#define SOUND4_ENVELOP_STEP(x)	((x)<<8) // ٥ץƥå׻ 0-7
#define SOUND4_ENVELOP_DEC		((0)<<11) // ٥׸
#define SOUND4_ENVELOP_INC		((1)<<11) // ٥
#define SOUND4_ENVELOP_VALUE(x)	((x)<<12) // ٥׽ 0-15


// REG_SG41

#define SOUND4_DIVIDE_FREQ(x)	((x)<<0) //  0-7
#define SOUND4_STAGE_15	(0<<3)	// 󥿥ơ
#define SOUND4_STAGE_7	(1<<3)	// 

#define SOUND4_STAGE_FREQ(x) ((x)<<4) // ƥåפȤμ 0-13
#define SOUND4_CONTINUE	(0<<14) // ³
#define SOUND4_TIMED	(1<<14) // 
#define SOUND4_RESET	(1<<15) // 1ꥻå



// REG_SGCNT_H

// GB4ͥνϥ쥷󡢣󡢣
#define SOUND_GB_RATIO_25	0
#define SOUND_GB_RATIO_50	1
#define SOUND_GB_RATIO_100	2

// DirectSound AB ϥ쥷󡢣
#define SOUND_DSOUNDA_RATIO_50	0
#define SOUND_DSOUNDA_RATIO_100	(1<<2)
#define SOUND_DSOUNDB_RATIO_50	0
#define SOUND_DSOUNDB_RATIO_100	(1<<3)

// DirectSoundA򺸱Υԡ˽Ϥ뤫
#define SOUND_DSOUNDA_OUTPUT_RIGHT	(1<<8)
#define SOUND_DSOUNDA_OUTPUT_LEFT	(1<<9)

// DirectSoundAǥޡ0ޡΤɤѤ뤫
#define SOUND_DSOUNDA_SAMP_TIMER0	0
#define SOUND_DSOUNDA_SAMP_TIMER1	(1<<10)

// DirectSoundAFIFOꥻåȤ
#define SOUND_DSOUNDA_FIFO_RESET	(1<<11)


// DirectSoundB򺸱Υԡ˽Ϥ뤫
#define SOUND_DSOUNDB_OUTPUT_RIGHT	(1<<12)
#define SOUND_DSOUNDB_OUTPUT_LEFT	(1<<13)

// DirectSoundBǥޡ0ޡΤɤѤ뤫
#define SOUND_DSOUNDB_SAMP_TIMER0	0
#define SOUND_DSOUNDB_SAMP_TIMER1	(1<<14)

// DirectSoundBFIFOꥻåȤ
#define SOUND_DSOUNDB_FIFO_RESET	(1<<15)












//---------------------------------------------------------------------------
#define SOUNDCNT_L	*(volatile u16*)0x4000080
#define SOUNDCNT_H	*(volatile u16*)0x4000082
#define SOUNDCNT_X	*(volatile u16*)0x4000084
#define SOUNDBIAS	*(volatile u16*)0x4000088


#define FIFO_A		0x40000A0
#define FIFO_B		0x40000A4



  //SOUNDCNT_L
#define ENABLE_SOUND1_LEFT		0x1000
#define ENABLE_SOUND2_LEFT		0x2000
#define ENABLE_SOUND3_LEFT		0x4000
#define ENABLE_SOUND4_LEFT		0x8000

#define ENABLE_SOUND1_RIGHT		0x0100
#define ENABLE_SOUND2_RIGHT		0x0200
#define ENABLE_SOUND3_RIGHT		0x0400
#define ENABLE_SOUND4_RIGHT		0x0800



  //SOUNDCNT_H
#define RESET_DSOUND_A			0x0800
#define DSOUND_A_TIMER0			0x0000
#define DSOUND_A_TIMER1			0x0400
#define ENABLE_DSOUND_A_LEFT	0x0200
#define ENABLE_DSOUND_A_RIGHT	0x0100
#define DSOUND_A_FULL_OUTPUT	0x0004

#define RESET_DSOUND_B			0x8000
#define DSOUND_B_TIMER0			0x0000
#define DSOUND_B_TIMER1			0x4000
#define ENABLE_DSOUND_B_LEFT	0x2000
#define ENABLE_DSOUND_B_RIGHT	0x1000
#define DSOUND_B_FULL_OUTPUT	0x0008

  //SOUNDCNT_X
#define ENABLE_SOUND_MASTER		0x0080
#define ENABLE_SOUND1			0x0001
#define ENABLE_SOUND2			0x0002
#define ENABLE_SOUND3			0x0004
#define ENABLE_SOUND4			0x0008








#ifdef __cplusplus
}
#endif
#endif
