//SOLACũ\[XR[hȂQlɂč܂B
//Ă邱Ƃ͂قƂǓłB
//http://satolab.com/GBA%B3%AB%C8%AF/SOLA.html

#include "inc.h"
#include "gbfs.h"
#include "lib.h"
#include "minix.h"
#include "div_arm.h"

#include "mml_arm.h"

//---------------------------------------------------------------------------
u16 MmlFleqTable[14][10] = {
	{0, 0, 0,       0,  FLEQ_B3,  FLEQ_B4,  FLEQ_B5,  FLEQ_B6,  FLEQ_B7,  0},
	{7, 0, 0, FLEQ_C3,  FLEQ_C4,  FLEQ_C5,  FLEQ_C6,  FLEQ_C7,  FLEQ_C8,  0},
	{7, 0, 0, FLEQ_CS3, FLEQ_CS4, FLEQ_CS5, FLEQ_CS6, FLEQ_CS7, FLEQ_CS8, 0},
	{6, 0, 0, FLEQ_D3,  FLEQ_D4,  FLEQ_D5,  FLEQ_D6,  FLEQ_D7,  FLEQ_D8,  0},
	{6, 0, 0, FLEQ_DS3, FLEQ_DS4, FLEQ_DS5, FLEQ_DS6, FLEQ_DS7, FLEQ_DS8, 0},
	{5, 0, 0, FLEQ_E3,  FLEQ_E4,  FLEQ_E5,  FLEQ_E6,  FLEQ_E7,  FLEQ_E8,  0},
	{4, 0, 0, FLEQ_F3,  FLEQ_F4,  FLEQ_F5,  FLEQ_F6,  FLEQ_F7,  FLEQ_F8,  0},
	{4, 0, 0, FLEQ_FS3, FLEQ_FS4, FLEQ_FS5, FLEQ_FS6, FLEQ_FS7, FLEQ_FS8, 0},
	{3, 0, 0, FLEQ_G3,  FLEQ_G4,  FLEQ_G5,  FLEQ_G6,  FLEQ_G7,  FLEQ_G8,  0},
	{3, 0, 0, FLEQ_GS3, FLEQ_GS4, FLEQ_GS5, FLEQ_GS6, FLEQ_GS7, FLEQ_GS8, 0},
	{2, 0, 0, FLEQ_A3,  FLEQ_A4,  FLEQ_A5,  FLEQ_A6,  FLEQ_A7,  FLEQ_A8,  0},
	{2, 0, 0, FLEQ_AS3, FLEQ_AS4, FLEQ_AS5, FLEQ_AS6, FLEQ_AS7, FLEQ_AS8, 0},
	{1, 0, 0, FLEQ_B3,  FLEQ_B4,  FLEQ_B5,  FLEQ_B6,  FLEQ_B7,  FLEQ_B8,  0},
	{0, 0, 0, FLEQ_C4,  FLEQ_C5,  FLEQ_C6,  FLEQ_C7,  FLEQ_C8,  0,        0},
};


//---------------------------------------------------------------------------
ST_MML Mml;


//---------------------------------------------------------------------------
IWRAM_CODE void MmlInit()
{
	MmlInitSound();

	MmlInitStatus(&Mml.ch1, 1);		//ቹp
	MmlInitStatus(&Mml.ch2, 2);		//fBp
	MmlInitStatus(&Mml.ch4, 4);		//ʉp
}
//---------------------------------------------------------------------------
IWRAM_CODE void MmlInitSound()
{
	REG_SGCNT1   = ALL_SOUND_ENABLE;
	REG_SGCNT0_L = DMG_LEFT_VOLUME(2) | DMG_RIGHT_VOLUME(2) |
	               SOUND1_LEFT_OUTPUT | SOUND1_RIGHT_OUTPUT |
	               SOUND2_LEFT_OUTPUT | SOUND2_RIGHT_OUTPUT |
	               SOUND3_LEFT_OUTPUT | SOUND3_RIGHT_OUTPUT |
	               SOUND4_LEFT_OUTPUT | SOUND4_RIGHT_OUTPUT;

	REG_SGCNT0_H = SOUND_OUTPUT_RATIO(2);

	REG_IE       |= IRQ_BIT_VBLANK;
	REG_DISPSTAT |= DSTAT_USE_VBLANK;
}
//---------------------------------------------------------------------------
IWRAM_CODE void MmlInitStatus(ST_MML_STATUS* p, u8 ch)
{
	p->pStr        = NULL;
	p->pCur        = NULL;
	p->pPrev       = NULL;
	p->tempo       = TEMPO_MAGIC / 120;
	p->len         = 4;
	p->lenOnce     = 0;
	p->lenCtdn     = 0;
	p->octave      = (ch != 4) ? 4 : 0;		//0ɂ̓p[JbVp̃f[^Ă
	p->fleq        = 0;
	p->isRelativeX = FALSE;
	p->isRepeat    = FALSE;
	p->isPlay      = FALSE;
	p->isErr       = FALSE;
	p->volume      = 7;
	p->tone        = 3;
	p->envelopStep = 7;
	p->sweepInc    = FALSE;
	p->sweepShift  = 0;
	p->sweepTime   = 0;
}
//---------------------------------------------------------------------------
//Z`gĐ+XC[v+Gx[v
IWRAM_CODE void MmlPlayCh1()
{
	ST_MML_STATUS* p = &Mml.ch1;

	if(p->fleq == 0)
	{
		REG_SG10_H = 0;
		REG_SG10_L = 0;
		return;
	}


	REG_SG10_H = SOUND1_SWEEP_SHIFT(p->sweepShift)   |
	             SOUND1_SWEEP_TIME(p->sweepTime)     |
	             SOUND1_LENGTH(0)                    |
	             SOUND1_DUTY_CYCLE(p->tone)          |
	             SOUND1_ENVELOP_STEP(p->envelopStep) |
	             SOUND1_ENVELOP_DEC                  |
	             SOUND1_ENVELOP_VALUE(p->volume);

	if(p->sweepInc == TRUE)
	{
		REG_SG10_L |= SOUND1_SWEEP_INC;
	}
	else
	{
		REG_SG10_L |= SOUND1_SWEEP_DEC;
	}

	REG_SG11 = SOUND1_FREQ(p->fleq) | SOUND1_CONTINUE | SOUND1_RESET;
}
//---------------------------------------------------------------------------
//Z`gĐ+Gx[v
IWRAM_CODE void MmlPlayCh2()
{
	ST_MML_STATUS* p = &Mml.ch2;

	if(p->fleq == 0)
	{
		REG_SG20_H = 0;
		REG_SG20_L = 0;
		return;
	}


	REG_SG20_L = SOUND2_LENGTH(0)                    |
	             SOUND2_DUTY_CYCLE(p->tone)          |
	             SOUND2_ENVELOP_STEP(p->envelopStep) |
	             SOUND2_ENVELOP_DEC                  |
	             SOUND2_ENVELOP_VALUE(p->volume);

	REG_SG21   = SOUND2_FREQ(p->fleq) | SOUND2_CONTINUE | SOUND2_RESET;
}
//---------------------------------------------------------------------------
//zCgmCYĐ+Gx[v
IWRAM_CODE void MmlPlayCh4()
{
	ST_MML_STATUS* p = &Mml.ch4;

	if(p->fleq == 0)
	{
		REG_SG40 = 0;
		REG_SG41 = 0;
		return;
	}


	REG_SG40 = SOUND4_LENGTH(0)                    |
	           SOUND4_ENVELOP_STEP(p->envelopStep) |
	           SOUND4_ENVELOP_DEC                  |
	           SOUND4_ENVELOP_VALUE(p->volume);

	REG_SG41 = SOUND4_STAGE_FREQ(6 - p->tone * 2)  |
	           SOUND4_DIVIDE_FREQ(p->fleq)         |
	           SOUND4_CONTINUE                     |
	           SOUND4_RESET                        |
	           SOUND4_STAGE_15;
}
//---------------------------------------------------------------------------
IWRAM_CODE void MmlHandler()
{
	if(Mml.ch1.isPlay == TRUE)
	{
		MmlHandlerSub(&Mml.ch1, 1);
	}

	if(Mml.ch2.isPlay == TRUE)
	{
		MmlHandlerSub(&Mml.ch2, 2);
	}

	if(Mml.ch4.isPlay == TRUE)
	{
		MmlHandlerSub(&Mml.ch4, 4);
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void MmlHandlerSub(ST_MML_STATUS* p, u8 ch)
{
	if(p->lenCtdn != 0)
	{
		p->lenCtdn--;
		return;
	}


	do {
		p->fleq = MmlGetFleq(p);

	} while(p->fleq == FLEQ_CTL);

	if(p->fleq == FLEQ_ERR)
	{
		MmlStop(p);
		p->isErr = TRUE;
		return;
	}

	if( (p->fleq == FLEQ_END) && (p->isRepeat == FALSE) )
	{
		MmlStop(p);
		return;
	}

	switch(ch)
	{
	case 1:
		MmlPlayCh1();
		break;

	case 2:
		MmlPlayCh2();
		break;

	case 4:
		MmlPlayCh4();
		break;
	}

	p->lenCtdn = MmlGetLenCtdn(p);
}
//---------------------------------------------------------------------------
IWRAM_CODE s16 MmlGetLenCtdn(ST_MML_STATUS* p)
{
	if(p->lenOnce != 0)
	{
		s16 ret    = p->lenOnce;
		p->lenOnce = 0;

		return ret;
	}

	return p->len;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 MmlGetNextDat(ST_MML_STATUS* p)
{
	u8 dat;

	//1ÕJ[\ʒuۑ܂
	p->pPrev = p->pCur;

	do {
		dat = *p->pCur++;

	} while(dat == ' ');


	if(dat == '\0')
	{
		if(p->isRepeat == TRUE)
		{
			p->pCur =  p->pStr;
			dat     = *p->pCur;
		}
    }

	return dat;
}
//---------------------------------------------------------------------------
IWRAM_CODE u8 MmlGetToken(u8 dat)
{
	switch(dat)
	{
	case 'R':
	case 'r':
		return TOKEN_REST;

	case 'C':
	case 'c':
		return TOKEN_C;

	case 'D':
	case 'd':
		return TOKEN_D;

	case 'E':
	case 'e':
		return TOKEN_E;

	case 'F':
	case 'f':
		return TOKEN_F;

	case 'G':
	case 'g':
		return TOKEN_G;

	case 'A':
	case 'a':
		return TOKEN_A;

	case 'B':
	case 'b':
		return TOKEN_B;

	case 'O':
	case 'o':
		return TOKEN_OCTAVE;

	case '>':
		return TOKEN_OCTAVE_UP;

	case '<':
		return TOKEN_OCTAVE_DOWN;

	case 'X':
	case 'x':
		return TOKEN_RELATIVE_X;

	case 'L':
	case 'l':
		return TOKEN_LEN;

	case '.':
		return TOKEN_PERIOD;

	case 'T':
	case 't':
		return TOKEN_TEMPO;

	case '#':
	case '+':
		return TOKEN_SHARP;

	case '-':
		return TOKEN_FLAT;

	case 'V':
	case 'v':
		return TOKEN_VOLUME;

	case '@':
		return TOKEN_TONE;

	case 'Q':
	case 'q':
		return TOKEN_ENVELOP_STEP;

	case 'S':
	case 's':
		return TOKEN_SWEEP;

	case ',':
		return TOKEN_CANMA;

	case '\0':
		return TOKEN_END;
    }

	return TOKEN_ERR;
}
//---------------------------------------------------------------------------
IWRAM_CODE u16 MmlGetFleq(ST_MML_STATUS* p)
{
	u8  dat, dat2;
	u16 tok, tok2;
	u16 i;
	u16 num;

	dat = MmlGetNextDat(p);
    tok = MmlGetToken(dat);

//	TRACEOUT("%c\n", dat);

	switch(tok)
	{
	// error
	case TOKEN_ERR:
		return FLEQ_ERR;

	// end
	case TOKEN_END:
		return FLEQ_END;

	// R
	case TOKEN_REST:
		return FLEQ_REST;

	// X
	case TOKEN_RELATIVE_X:
		p->isRelativeX = TRUE;
		return FLEQ_CTL;

	// >
	case TOKEN_OCTAVE_UP:
		if(p->isRelativeX == FALSE)
		{
			MmlUpOctave(p);
		}
		else
		{
			MmlDownOctave(p);
		}
		return FLEQ_CTL;

	// <
	case TOKEN_OCTAVE_DOWN:
		if(p->isRelativeX == FALSE)
		{
			MmlDownOctave(p);
		}
		else
		{
			MmlUpOctave(p);
		}
		return FLEQ_CTL;

	// On
	case TOKEN_OCTAVE:
		dat = MmlGetNextDat(p);

		if( (MmlIsNumber(dat) == TRUE) && (MmlIsOctave(dat - '0') == TRUE) )
		{
			p->octave = dat - '0';
		}
		else
		{
			return FLEQ_ERR;
		}
		return FLEQ_CTL;

	// @n
	case TOKEN_TONE:
		dat = MmlGetNextDat(p);

		if( (MmlIsNumber(dat) == TRUE) && (MmlIsTone(dat - '0') == TRUE) )
		{
			p->tone = dat - '0';
		}
		else
		{
			return FLEQ_ERR;
		}
		return FLEQ_CTL;

	// Qn
	case TOKEN_ENVELOP_STEP:
		dat = MmlGetNextDat(p);

		if( (MmlIsNumber(dat) == TRUE) && (MmlIsEnvelopStep(dat - '0') == TRUE) )
		{
			p->envelopStep = dat - '0';
		}
		else
		{
			return FLEQ_ERR;
		}
		return FLEQ_CTL;

	// Sn,m
	case TOKEN_SWEEP:
		// n
		dat = MmlGetNextDat(p);

		if( (MmlIsNumber(dat) == TRUE) && (MmlIsSweepTime(dat - '0') == TRUE) )
		{
			p->sweepTime = dat - '0';
		}
		else
		{
			return FLEQ_ERR;
		}

		// ,
		dat = MmlGetNextDat(p);

		if(dat != ',')
		{
			return FLEQ_ERR;
		}

		// -
		dat = MmlGetNextDat(p);
	    tok = MmlGetToken(dat);

		if(tok == TOKEN_FLAT)
		{
			p->sweepInc = FALSE;
		}
		else
		{
			MmlSetPrevCur(p);
			p->sweepInc = TRUE;
		}

		// m
		dat = MmlGetNextDat(p);

		if( (MmlIsNumber(dat) == TRUE) && (MmlIsSweepShift(dat - '0') == TRUE) )
		{
			p->sweepShift = dat - '0';
		}
		else
		{
			return FLEQ_ERR;
		}
		return FLEQ_CTL;

	// Lnn
	case TOKEN_LEN:
		num = 0;

		// n(2)
		for(i=0; i<2; i++)
		{
			dat = MmlGetNextDat(p);
			if( MmlIsNumber(dat) == TRUE )
			{
				num = (num * 10) + (dat - '0');
			}
			else
			{
				MmlSetPrevCur(p);
				break;
			}
		}

		if( MmlIsLen(num) == FALSE )
		{
			return FLEQ_ERR;
		}

		p->len = _UDiv(p->tempo, num);
		return FLEQ_CTL;

	// Vnn
	case TOKEN_VOLUME:
		num = 0;

		// n(2)
		for(i=0; i<2; i++)
		{
			dat = MmlGetNextDat(p);
			if( MmlIsNumber(dat) == TRUE )
			{
				num = (num * 10) + (dat - '0');
			}
			else
			{
				MmlSetPrevCur(p);
				break;
			}
		}

		if( MmlIsVolume(num) == FALSE )
		{
			return FLEQ_ERR;
		}

		p->volume = num;
		return FLEQ_CTL;

	// Tnnn
	case TOKEN_TEMPO:
		num = 0;

		// n(3)
		for(i=0; i<3; i++)
		{
			dat = MmlGetNextDat(p);
			if( MmlIsNumber(dat) == TRUE )
			{
				num = (num * 10) + (dat - '0');
			}
			else
			{
				MmlSetPrevCur(p);
				break;
			}
		}

		if( MmlIsTempo(num) == FALSE )
		{
			return FLEQ_ERR;
		}

		p->tempo = num;
		return FLEQ_CTL;

	// 
	case TOKEN_C:
	case TOKEN_D:
	case TOKEN_E:
	case TOKEN_F:
	case TOKEN_G:
	case TOKEN_A:
	case TOKEN_B:
		// ̂ # + -
		dat2 = MmlGetNextDat(p);
	    tok2 = MmlGetToken(dat);

		if(tok2 == TOKEN_SHARP)
		{
			tok++;
		}
		else if(tok2 == TOKEN_FLAT)
		{
			tok--;
		}
		else
		{
			MmlSetPrevCur(p);
		}

		// `FbN܂
		dat2 = MmlGetNextDat(p);
		if(MmlIsNumber(dat2) == FALSE)
		{
			MmlSetPrevCur(p);
			return MmlFleqTable[tok][p->octave];
		}

		num = dat2 - '0';

		// ɐ`FbN܂
		dat2 = MmlGetNextDat(p);
	    tok2 = MmlGetToken(dat);
		if( MmlIsNumber(dat2) == TRUE )
		{
			num = (num * 10) + (dat2 - '0');
		}
		else
		{
			MmlSetPrevCur(p);
		}

		if( MmlIsOctave(num) == FALSE )
		{
			return FLEQ_ERR;
		}
		p->lenOnce = _UDiv(p->tempo, num);

		// sIh邩`FbN܂iQmFj
		for(i=0; i<2; i++)
		{
			dat2 = MmlGetNextDat(p);

			if(dat2 == '.')
			{
				p->lenOnce += _UDiv(p->tempo, _UDiv(num, ((i*2)+2)) );
			}
			else
			{
				MmlSetPrevCur(p);
				break;
			}
		}

		return MmlFleqTable[tok][p->octave];
	}

	return FLEQ_ERR;
}
//---------------------------------------------------------------------------
IWRAM_CODE void MmlSetPrevCur(ST_MML_STATUS* p)
{
	p->pCur = p->pPrev;
}
//---------------------------------------------------------------------------
IWRAM_CODE void MmlSetStr(u8 ch, char* pStr)
{
	switch(ch)
	{
	case 1:
		MmlInitStatus(&Mml.ch1, 1);
		Mml.ch1.pStr = (u8*)pStr;
		Mml.ch1.pCur = (u8*)pStr;
		break;

	case 2:
		MmlInitStatus(&Mml.ch2, 2);
		Mml.ch2.pStr = (u8*)pStr;
		Mml.ch2.pCur = (u8*)pStr;
		break;

	case 4:
		MmlInitStatus(&Mml.ch4, 4);
		Mml.ch4.pStr = (u8*)pStr;
		Mml.ch4.pCur = (u8*)pStr;
		break;
	}
}




//---------------------------------------------------------------------------
IWRAM_CODE bool MmlIsOctave(s16 num)
{
	return (num >= 3) && (num <= 8) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE bool MmlIsTone(s16 num)
{
	return (num >= 0) && (num <= 3) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE bool MmlIsEnvelopStep(s16 num)
{
	return (num >= 0) && (num <= 7) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE bool MmlIsSweepTime(s16 num)
{
	return (num >= 0) && (num <= 7) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE bool MmlIsSweepShift(s16 num)
{
	return (num >= 0) && (num <= 7) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE bool MmlIsLen(s16 num)
{
	return (num >= 1) && (num <= 64) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE bool MmlIsVolume(s16 num)
{
	return (num >= 0) && (num <= 15) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE bool MmlIsTempo(s16 num)
{
	return (num >= 1) && (num <= 255) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE bool MmlIsNumber(u8 chr)
{
	return ( (chr >= '0') && (chr <= '9') ) ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
IWRAM_CODE bool MmlIsPlay()
{
	bool ret = FALSE;

	ret |= Mml.ch1.isPlay;
	ret |= Mml.ch2.isPlay;
	ret |= Mml.ch4.isPlay;

	return ret;
}




//---------------------------------------------------------------------------
IWRAM_CODE void MmlPlay()
{
	if(Mml.ch1.pStr != NULL) Mml.ch1.isPlay = TRUE;
	if(Mml.ch2.pStr != NULL) Mml.ch2.isPlay = TRUE;
	if(Mml.ch4.pStr != NULL) Mml.ch4.isPlay = TRUE;
}
//---------------------------------------------------------------------------
IWRAM_CODE void MmlPlayRepeat()
{
	Mml.ch1.isRepeat = TRUE;
	Mml.ch2.isRepeat = TRUE;
	Mml.ch4.isRepeat = TRUE;

	MmlPlay();
}
//---------------------------------------------------------------------------
IWRAM_CODE void MmlStop()
{
	Mml.ch1.isPlay = FALSE;
	Mml.ch2.isPlay = FALSE;
	Mml.ch4.isPlay = FALSE;

	Mml.ch1.fleq   = 0;
	Mml.ch2.fleq   = 0;
	Mml.ch4.fleq   = 0;
	MmlPlayCh1();
	MmlPlayCh2();
	MmlPlayCh4();
}
//---------------------------------------------------------------------------
IWRAM_CODE void MmlDownOctave(ST_MML_STATUS* p)
{
	if( MmlIsOctave(p->octave - 1) == TRUE )
	{
		p->octave--;
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void MmlUpOctave(ST_MML_STATUS* p)
{
	if( MmlIsOctave(p->octave + 1) == TRUE )
	{
		p->octave++;
	}
}
